#ifndef _NUMBERLINE_H
#define _NUMBERLINE_H

#include <QtGui>

class QTextEdit;
class QHBoxLayout;
class TextView;
class MainWindow;

class NumberLine : public QWidget
{
    Q_OBJECT

public:
    NumberLine( QWidget *parent );
    ~NumberLine();

	// Breakpoint
	void setCurrentLine(int lineno);
    void setBreakpoint(int lineno);
	void AllBreakpointClear();
	void BreakpointClear(int lineno);
	
	// Edit
    void setTextEdit(QTextEdit *edit);
    
	// Mark
	void paintEvent(QPaintEvent *ev);

	QList <int> list;
	
protected:
    bool event( QEvent *ev );

private:
    QTextEdit *edit;
    QPixmap stopMarker;
	
    int m_currentLine;
    QRect stopRect[15];;
};

#endif // _NUMBERLINE_H


